-- Additional lights made by AR162b for BeamNG.Drive

local M = {}

local blinkPDTimerThreshold = 0.4
local blinkPDTimerThresholdHalf = 0.0
local blinkPDTimer = 0
local blinkPDTimerMode = 0
local blinkPDTimer = 0
local blinkPDPulseLeft = 0
local blinkPDPulseRight = 1
local blinkPDModeA = 0
local blinkPDModeB = 1
local spinning = 0
local lightbarStatusAR162b1 = 0
local lightbarStatusAR162b2 = 0
local blinkshorttime = 0.07
local blinkPDPulseShortLeft = 0
local blinkPDPulseShortRight = 0
local blinkerFlashing = 0
local spotlightsteerAR162b_r = 0
local spotlightsteerAR162b_l = 0
local spotlightAR162b_l = 0


local function onInit()

	electrics.values['PD_R'] = 0
	electrics.values['PD_L'] = 0

	electrics.values['spinright'] = 0
	electrics.values['spinleft'] = 0
	
	electrics.values['signal_R_PD'] = 0
	electrics.values['signal_L_PD'] = 0
	
	electrics.values['spotlightsteerRAR162b'] = 0
	electrics.values['spotlightsteerLAR162b'] = 0
	electrics.values['spotlightAR162b'] = 0
	
end

local function reset()
	onInit()
end

local function calculateLightbarStatusAR162b()

	if electrics.values['lightbar'] == 0 then
	lightbarStatusAR162b1 = 0
	lightbarStatusAR162b2 = 0
	elseif electrics.values['lightbar'] == 1 then
	lightbarStatusAR162b1 = 1
	lightbarStatusAR162b2 = 0
	elseif electrics.values['lightbar'] == 2 then
	lightbarStatusAR162b1 = 1
	lightbarStatusAR162b2 = 1
	else
	lightbarStatusAR162b1 = 0
	lightbarStatusAR162b2 = 0
	end
end


local function calculatespotlightR162b()

	if electrics.values['fog'] == 0 then
		spotlightsteerAR162b_l = 1
		spotlightsteerAR162b_r = -1
		spotlightAR162b_l = 1
	else 
		spotlightsteerAR162b_l = electrics.values['steering_input']
		spotlightsteerAR162b_r = electrics.values['steering_input']
		spotlightAR162b_l = 0
	end
	
end

local function generateBlinkPDTimer(dt)

    blinkPDTimerThresholdHalf = (blinkPDTimerThreshold / 2) * lightbarStatusAR162b2

    blinkPDTimer = blinkPDTimer + (dt)

    if blinkPDTimer > blinkPDTimerThreshold then
        blinkPDTimer = blinkPDTimer - blinkPDTimerThreshold
	blinkPDPulseLeft = 0
	blinkPDPulseRight = 1
	else
    if blinkPDTimer > blinkPDTimerThresholdHalf then
	blinkPDPulseLeft = 1
	blinkPDPulseRight = 0
	end
    end
end

local function generateBlinkPDTimerMode(dt)

    blinkPDTimerMode = (blinkPDTimerMode + (dt)) * lightbarStatusAR162b2

    if blinkPDTimerMode > 7 then
        blinkPDTimerMode = blinkPDTimerMode - 7
	blinkPDModeA = 0
	blinkPDModeB = 1
	else
    if blinkPDTimerMode > 5 then
	blinkPDModeA = 1
	blinkPDModeB = 0
	end
    end
end


local function generateSpinning(dt)

    		if spinning > 359 then
        		spinning = 0
		else
			spinning = spinning + (((dt * 100) % 360) * lightbarStatusAR162b1)
		end
    	
end

local function generateBlinkerFlashing(dt)
	
		blinkerFlashing = blinkerFlashing + (dt)
		if blinkerFlashing > (9*blinkshorttime) then
				blinkerFlashing = 0
		end
		
		if electrics.values['signal_left_input'] == 1 then
			blinkPDPulseShortLeft = electrics.values['signal_L']
		elseif lightbarStatusAR162b2 == 1 then
			if blinkerFlashing > (8*blinkshorttime) then
				blinkPDPulseShortLeft = 0
			elseif blinkerFlashing > (7*blinkshorttime) then
				blinkPDPulseShortLeft = 0
			elseif blinkerFlashing > (6*blinkshorttime) then
				blinkPDPulseShortLeft = 0
			elseif blinkerFlashing > (5*blinkshorttime) then
				blinkPDPulseShortLeft = 0
			elseif blinkerFlashing > (4*blinkshorttime) then
				blinkPDPulseShortLeft = 1
			elseif blinkerFlashing > (3*blinkshorttime) then
				blinkPDPulseShortLeft = 0
			elseif blinkerFlashing > (2*blinkshorttime) then
				blinkPDPulseShortLeft = 1
			elseif blinkerFlashing > (1*blinkshorttime) then
				blinkPDPulseShortLeft = 0
			end
		else
			blinkPDPulseShortLeft = 0
		end
		
		if electrics.values['signal_right_input'] == 1 then
			blinkPDPulseShortRight = electrics.values['signal_R']
		elseif lightbarStatusAR162b2 == 1 then
			if blinkerFlashing > (8*blinkshorttime) then
				blinkPDPulseShortRight = 1
			elseif blinkerFlashing > (7*blinkshorttime) then
				blinkPDPulseShortRight = 0
			elseif blinkerFlashing > (6*blinkshorttime) then
				blinkPDPulseShortRight = 1
			elseif blinkerFlashing > (5*blinkshorttime) then
				blinkPDPulseShortRight = 0
			elseif blinkerFlashing > (4*blinkshorttime) then
				blinkPDPulseShortRight = 0
			elseif blinkerFlashing > (3*blinkshorttime) then
				blinkPDPulseShortRight = 0
			elseif blinkerFlashing > (2*blinkshorttime) then
				blinkPDPulseShortRight = 0
			elseif blinkerFlashing > (1*blinkshorttime) then
				blinkPDPulseShortRight = 0
			end
		else
			blinkPDPulseShortRight = 0
		end
		
end


local function updateGFX(dt)
	
    local vals = M.values
	calculateLightbarStatusAR162b()
    generateBlinkPDTimer(dt)	
    generateBlinkPDTimerMode(dt)
    generateSpinning(dt)
	generateBlinkerFlashing(dt)
	calculatespotlightR162b()


    	electrics.values['PD_R'] = (lightbarStatusAR162b2  * ((blinkPDPulseRight * blinkPDModeB) + (blinkPDPulseLeft * blinkPDModeA)))
    	electrics.values['PD_L'] = (lightbarStatusAR162b2  * blinkPDPulseLeft)
		electrics.values['spinright'] = (spinning)
    	electrics.values['spinleft'] = (360 - spinning)
		electrics.values['signal_L_PD'] = blinkPDPulseShortLeft
    	electrics.values['signal_R_PD'] = blinkPDPulseShortRight
		electrics.values['spotlightsteerRAR162b'] = spotlightsteerAR162b_r
		electrics.values['spotlightsteerLAR162b'] = spotlightsteerAR162b_l
		electrics.values['spotlightAR162b'] = spotlightAR162b_l
		

end

 


-- public interface
M.Reset       = Reset
M.onInit	= onInit
M.updateGFX   = updateGFX

return M